﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Infragistics.Controls.Charts;

namespace AutoScaleYBasedOnX
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }

        private void xmDataChart_WindowRectChanged(object sender, Infragistics.RectChangedEventArgs e)
        {
            StockMarketDataCollection stocks = root.DataContext as StockMarketDataCollection;

            ScalerParams xParams = new ScalerParams(xmDataChart.WindowRect, xmDataChart.ViewportRect, xmXAxis.IsInverted);

            int firstVisibleIndex = (int)Math.Floor(xmXAxis.GetUnscaledValue(0, xParams));
            int lastVisibleIndex = (int)Math.Ceiling(xmXAxis.GetUnscaledValue(series.ActualWidth, xParams));

            double maxY = double.MinValue;
            double minY = double.MaxValue;

            for (int i = firstVisibleIndex; i <= lastVisibleIndex; i++)
            {
                StockMarketDataPoint point = stocks[i];
                if (minY > point.Low)
                    minY = point.Low;
                if (maxY < point.High)
                    maxY = point.High;
            }

            xmYAxis.MinimumValue = minY;
            xmYAxis.MaximumValue = maxY;
        }
    }
}
